#include "textures.inc"

#declare board = box
{
        < -1, -1, -1 >< 1, 1, 1 >        
        scale < 20, 0.01, 0.5 >   
        texture{wood_texture}
}

#declare stage_lamp = union
{
        cylinder
        {
                < 0, 0, 0 >< 0, 1, 0 >, 1
                scale< 0.5, 1, 0.5 >
                texture{ gold_texture }
        }
        union
        {
                difference
                {
                        difference
                        {
                                sphere
                                {
                                        <0, 0, 0 >, 1
                                }
                                sphere
                                {
                                        <0, 0, 0 >, 0.9
                                        texture{ reflector_texture }
                                }
                        }
                        box
                        {
                                < -1, -1, 0 >,< 1, 1, 1 >
                        }
                        texture{ lamp_texture }       
                        scale< 1.5, 0.5, 1.5 >
                }
                light_source
                { 
                        < 0, 0, 0 >
                        color rgb< 1, 1, 1 > 
                        
                        fade_power 3
                        fade_distance 1
                }                        
                translate< 0, 1.25, 0 >
        }
        scale< 0.05, 0.5, 0.05 >
}

#declare stage = union
{           
        union
        {
                object{board translate< 0, 0, 0 >}
                object{board translate< 0, 0, 1.1 >}
                object{board translate< 0, 0, 2.2 >}
                object{board translate< 0, 0, 3.3 >}
                object{board translate< 0, 0, 4.4 >}
                object{board translate< 0, 0, 5.5 >}
                object{board translate< 0, 0, 6.6 >}
                object{board translate< 0, 0, 7.7 >}
                object{board translate< 0, 0, 8.8 >}
                object{board translate< 0, 0, 9.9 >}
                object{board translate< 0, 0, 11.0 >}
                object{board translate< 0, 0, 12.1 >}
                object{board translate< 0, 0, 13.2 >}
                object{board translate< 0, 0, 14.3 >}
                object{board translate< 0, 0, 15.4 >}
                object{board translate< 0, 0, 16.5 >}
                object{board translate< 0, 0, 17.6 >}
                object{board translate< 0, 0, 18.7 >}
                object{board translate< 0, 0, 19.8 >}
                object{board translate< 0, 0, 20.9 >}
                object{board translate< 0, 0, 22.0 >}
        }
        union
        {
                difference
                {
                        box
                        {
                                <-1, -1, -1 >, < 1, 1, 1 >
                                scale< 20, 10, 0.05 >
                        }
                        box
                        {
                                <-1, -1, -1 >, < 1, 1, 1 >
                                scale< 10, 7, 1 >
                                translate< 0, -3.5, 0 >
                        }
                        translate< 0, 6, -0.5 >
                        texture{ wall_texture }
                }
        }        
        union
        {       
                difference
                {
                        sphere
                        {
                                < 0, 0, 0 >,1
                        }
                        union
                        {
                                box
                                {
                                        < -1, -1, 0 >< 1, 1, 1 >
                                }
                                box
                                {                               
                                        < -1, -1, -1 >< 1, 0, 1 >
                                }               
                                sphere
                                {
                                        <0, 0, 0 >, 0.9
                                }
                        }
                        scale< 1.5, 1.5, 1.5 >
                        texture{ red_texture }
                }
                difference
                {
                        intersection
                        {       
                                box
                                {
                                        < -1, -1, -1 > < 1, 1, 1 > 
                                }                
                                cylinder
                                {
                                        < 0, -2, 0 >< 0, 2, 0 >, 1
                                        scale< 1, 1, 2 >
                                        translate< 0, 0, 1 >
                                }
                
                                scale< 10, 2, 1 >
                                translate< 0, -1.9, -1 >
                        }
                        cylinder
                        {
                                < 0, -1, 0 ><0, 1, 0 >,1
                                scale< 1.5, 1.5, 1.5 >
                        }                               
                        texture{ darkwood_texture }
                }
                object{ stage_lamp rotate< 0, 0, 0 > translate< 3, 0, -1.4 >}
                object{ stage_lamp rotate< 0, -2, 0 > translate< 4, 0, -1.4 >}
                object{ stage_lamp rotate< 0, -5, 0 > translate< 5, 0, -1.3 >}
                object{ stage_lamp rotate< 0, -5, 0 > translate< 6, 0, -1.2 >}
                object{ stage_lamp rotate< 0, -10, 0 > translate< 7, 0, -1.0 >}
                object{ stage_lamp rotate< 0, -20, 0 > translate< 8, 0, -0.8 >}
                object{ stage_lamp rotate< 0, -45, 0 > translate< 9, 0, -0.5 >}
        
                object{ stage_lamp rotate< 0, 0, 0 > translate< -3, 0, -1.4 >}
                object{ stage_lamp rotate< 0, 2, 0 > translate< -4, 0, -1.4 >}
                object{ stage_lamp rotate< 0, 5, 0 > translate< -5, 0, -1.3 >}
                object{ stage_lamp rotate< 0, 5, 0 > translate< -6, 0, -1.2 >}
                object{ stage_lamp rotate< 0, 10, 0 > translate< -7, 0, -1.0 >}
                object{ stage_lamp rotate< 0, 20, 0 > translate< -8, 0, -0.8 >}
                object{ stage_lamp rotate< 0, 45, 0 > translate< -9, 0, -0.5 >}
        
                translate< 0, 0, -0.5 >
        }
        union
        {
                intersection
                {
                        sphere
                        {
                                <0, 0, 0>, 1  
                        }                     
                        box
                        {
                                <0, 0, -1 >< 1, 1, 1 >
                        }
                        scale< 2, 10.5, 1 >
                        translate< -11, 0, -0.5 >
                        texture{ curtain_texture }
                }
                intersection
                {
                        sphere
                        {
                                <0, 0, 0>, 1  
                        }                     
                        box
                        {
                                <-1, 0, -1 >< 0, 1, 1 >
                        }
                        scale< 2, 10.5, 1 >
                        translate< 11, 0, -0.5 >
                        texture{ curtain_texture }
                }
                union
                {
                        sphere
                        {
                                <0, 0, 0>, 1            
                                scale< 5.5, 2, 1 >
                                translate< 5, 10, -0.5 >
                                texture{ curtain_texture rotate< 0, 0, 90 > }
                        }
                        sphere
                        {
                                <0, 0, 0>, 1             
                                scale< 5.5, 2, 1 >
                                translate< -5, 10, -0.5 >
                                texture{ curtain_texture rotate< 0, 0, 90 > }
                        }                     
                        sphere
                        {
                                <0, 0, 0>, 1            
                                translate< 0, 10, -0.5 >
                                texture{ curtain_texture rotate< 0, 0, 90 > }
                        }
                }
        }
}
